/**
 * Created with IntelliJ IDEA.
 * User: aaronlin
 * Date: 2018/6/5
 * Time: 15:38
 */

import React,{ PureComponent } from 'react';
import {
    Modal,
    View,
} from 'react-native';

import StaticContainer from 'static-container';

import emitter from '../toast/lib/AppRegistryInjection';

const siblings = new Map();
const updates = new Set();

export default class WMModal extends PureComponent{

    constructor(props){
        super(props);
    }

    componentWillMount() {
        this._update = this._update.bind(this);
        emitter.addListener('siblings.update', this._update);
    };

    componentWillUnmount() {
        emitter.removeListener('siblings.update', this._update);
        siblings.clear();
        updates.clear();
    };

    _update(id, element, callback) {
        if (siblings.has(id) && !element) {
            siblings.delete(id);
        } else {
            siblings.set(id, element);
        }
        updates.add(id);
        this.forceUpdate(callback);
    };

    render(){
        const { children, ...otherProps } = this.props;

        const elements = [];
        siblings.forEach((element, id) => {
            console.log('WMModal=======>')
            elements.push(
                <StaticContainer
                    key={`root-sibling-${id}`}
                    shouldUpdate={updates.has(id)}
                >
                    {element}
                </StaticContainer>
            );
        });
        updates.clear();

        return (
            <Modal
                {...otherProps}
            >

                <View style={styles.container}>
                    { children }
                    { elements }
                </View>

            </Modal>
        );
    }

}

const styles = {
    container: {
        flex: 1,
        position: 'relative',
    }
};