import React, {
    PureComponent,
} from 'react';

import {
    ViewPropTypes,
    ColorPropType,
} from 'react-native';

import PropTypes from 'prop-types';

import WMPickerView from './WMPickerView';

export default class PickerView extends PureComponent {

    constructor(props) {
        super(props);
    }

    smoothScrollToPosition = (position = 0, anim = true) => {
        this.refs.pickerView && this.refs.pickerView.smoothScrollToPosition(position, anim)
    }

    setData = (dataList) => {
        this.refs.pickerView && this.refs.pickerView.setData(dataList);
    }

    setSelectIndex = (index) => {
        this.refs.pickerView && this.refs.pickerView.setSelectIndex(index);
    }

    getTag = () => {
        return this.props.tag;
    }

    /**
     *
     * @param props
     */
    setNativeProps = (props) => {
        this.refs.pickerView && this.refs.pickerView.setNativeProps(props);
    }

    render() {
        return (
            <WMPickerView
                ref="pickerView"
                {...this.props}
            />
        );
    }

}

PickerView.propTypes = {
    ...ViewPropTypes,
    data: PropTypes.array,     //数据源  字符串数组
    itemTextColor: ColorPropType,    //字体颜色
    selectedItemTextColor: ColorPropType,    //被选中的字体颜色
    itemTextSize: PropTypes.number,    //字体大小
    selectedValue: PropTypes.number,    //默认选中的位置, 只能是数字   默认：0
    onValueChange: PropTypes.func, //某一项被选中时执行此回调
    tag: PropTypes.object,
}